# -*- coding: utf_8 -*-

from pandac.PandaModules import *
from direct.showbase import DirectObject
from direct.task import Task


class gameBot(DirectObject.DirectObject):
	def __init__(self, model, pos, nick):
	
		# грузим танк
		self.tank = loader.loadModel(model)
		self.tank.reparentTo(render)
		self.tank.setScale(0.0003,0.0003,0.0003)
		#tX,tY,tZ,tH,tP,tR=0,0,0.932,0,0,0
		tX,tY,tZ,tH,tP,tR=pos
		self.tank.setPos(tX,tY,tZ)
		self.tank.setHpr(tH,tP,tR)
		# угол поворота корпуса танка
		self.a = self.tank.getH()
		self.Zold = self.tank.getZ()
		
		#добавляем текст над танком
		font = loader.loadFont('arial.ttf')
		newTextNode = TextNode('text')
		newTextNode.setFont(font)
		newTextNode.setAlign(TextNode.ACenter)
		newTextNode.setText(nick)
		newTextNode.setShadow(0.05,0.05)
		newTextNode.setShadowColor(1, 1, 1, 0.5)
		newTextNode.setTextColor(0,0,0,1)
		newTextNode.setWordwrap(16.0)
		newTextNode.setFrameColor(0, 0, 1, 0.3)
		newTextNode.setFrameAsMargin(0.3, 0.3, 0.3, 0.3)
		newTextNode.setCardColor(1, 1, 0.5, 0.3)
		newTextNode.setCardAsMargin(0.3, 0.3, 0.3, 0.3)
		newTextNode.setCardDecal(True)
		
		text_generate = newTextNode.generate()
		self.newTextNodePath = render.attachNewNode(text_generate)
		self.newTextNodePath.setScale(0.08)
		self.newTextNodePath.setPos(self.tank.getPos())
		self.newTextNodePath.setZ(self.tank.getZ()+0.9)
		#self.newTextNodePath.setBillboardAxis()
		#self.newTextNodePath.setBillboardPointWorld()
		self.newTextNodePath.setBillboardPointEye()
		
		# разносим танк на детали
		self.stvol = self.tank.find('**/**/stvol')
		self.bashnya = self.tank.find('**/**/bashnya')
		
		###################################################################################################
		#                   К О Л Л И З И И
		self.cTrav = CollisionTraverser()
		
		# луч для коллиции с полом и нахождения нормали к поверхности
		# 1
		self.tankGroundRay1 = CollisionRay(0,0,3000,0,0,-1)
		self.tankGroundCol1 = CollisionNode('tankRay')
		self.tankGroundCol1.addSolid(self.tankGroundRay1)
		self.tankGroundCol1.setFromCollideMask(BitMask32.bit(1))
		self.tankGroundCol1.setIntoCollideMask(BitMask32.allOff())
		self.tankGroundColNp1 = self.tank.attachNewNode(self.tankGroundCol1)
		self.tankGroundHandler1 = CollisionHandlerQueue()
		self.cTrav.addCollider(self.tankGroundColNp1, self.tankGroundHandler1)
		self.tankGroundColNp1.show()
		
		# четыре шара по углам танка для коллиции с препядствиями
		# 1
		self.EnvDetector1=CollisionSphere(-700, 1900, 1900, 1000)
		self.EnvCol1 = CollisionNode('colEnv_1')
		self.EnvCol1.addSolid(self.EnvDetector1)
		self.EnvCol1.setFromCollideMask(BitMask32.bit(2))
		self.EnvCol1.setIntoCollideMask(BitMask32.allOff())
		self.EnvColNp1 = self.tank.attachNewNode(self.EnvCol1)
		#self.EnvColNp1.show()
		self.pusher1 = CollisionHandlerPusher()
		self.pusher1.addCollider(self.EnvColNp1, self.tank)
		self.cTrav.addCollider(self.EnvColNp1, self.pusher1)
		
		# 2
		self.EnvDetector2=CollisionSphere(700, 1900, 1900, 1000)
		self.EnvCol2 = CollisionNode('colEnv_2')
		self.EnvCol2.addSolid(self.EnvDetector2)
		self.EnvCol2.setFromCollideMask(BitMask32.bit(2))
		self.EnvCol2.setIntoCollideMask(BitMask32.allOff())
		self.EnvColNp2 = self.tank.attachNewNode(self.EnvCol2)
		#self.EnvColNp2.show()
		self.pusher2 = CollisionHandlerPusher()
		self.pusher2.addCollider(self.EnvColNp2, self.tank)
		self.cTrav.addCollider(self.EnvColNp2, self.pusher2)
		
		# 3
		self.EnvDetector3=CollisionSphere(-700, -1900, 1900, 1000)
		self.EnvCol3 = CollisionNode('colEnv_3')
		self.EnvCol3.addSolid(self.EnvDetector3)
		self.EnvCol3.setFromCollideMask(BitMask32.bit(2))
		self.EnvCol3.setIntoCollideMask(BitMask32.allOff())
		self.EnvColNp3 = self.tank.attachNewNode(self.EnvCol3)
		#self.EnvColNp3.show()
		self.pusher3 = CollisionHandlerPusher()
		self.pusher3.addCollider(self.EnvColNp3, self.tank)
		self.cTrav.addCollider(self.EnvColNp3, self.pusher3)
		
		# 4
		self.EnvDetector4=CollisionSphere(700, -1900, 1900, 1000)
		self.EnvCol4 = CollisionNode('colEnv_4')
		self.EnvCol4.addSolid(self.EnvDetector4)
		self.EnvCol4.setFromCollideMask(BitMask32.bit(2))
		self.EnvCol4.setIntoCollideMask(BitMask32.allOff())
		self.EnvColNp4 = self.tank.attachNewNode(self.EnvCol4)
		#self.EnvColNp4.show()
		self.pusher4 = CollisionHandlerPusher()
		self.pusher4.addCollider(self.EnvColNp4, self.tank)
		self.cTrav.addCollider(self.EnvColNp4, self.pusher4)
		#
		#self.cTrav.showCollisions(render)
		
		# включаем обработчик
		taskMgr.add(self.move,"moveTask")
	
	# обработчик движения танка камеры ствола башни и прочих камер
	def move(self, task):
		elapsed = globalClock.getDt()

		self.newTextNodePath.setPos(self.tank.getPos())
		self.newTextNodePath.setZ(self.tank.getZ()+1)
		
		#выходим из обработчика
		return Task.cont
